#include <stdio.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <signal.h>
#include <curses.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <arpa/inet.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/if_ether.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <netinet/ip_var.h>
#include <netinet/udp_var.h>
#include <net/route.h>
#include <net/nit.h>
#include <net/nit_if.h>
#include <net/nit_buf.h>
#include <sys/stropts.h>
#include <netdb.h>

#ifdef YP
struct stat_info {
  struct servent serv;
  int count;
  struct stat_info *next, *prev;
};

struct stats { 
  struct stat_info *head; 
  int num_services;
};

#include <netdb.h>
struct stats *get_services();
#else  
struct Stats{
  char *name;
  int port;
  int count;
  int prev;
};

struct Stats tcp[] = {
  "TCP",0,0,0,
  "telnet",23,0,0,
  "rlogin",513,0,0,
  "Xwindow",6000,0,0,
  "mail",25,0,0,
  "nntp",119,0,0,
  "rsh",514,0,0,
  "ftpdata",20,0,0,
  "ftp",21,0,0,
  "other",-1,0,0
  };

struct Stats udp[] = {
  "UDP",0,0,0,
  "nfs",2049,0,0,
  "domain",53,0,0,
  "ntp",123,0,0,
  "who",513,0,0,
  "syslog",514,0,0,
  "snmp",161,0,0,
  "other",-1,0,0
  };
#endif

union   netheader {
  struct  udpiphdr nh_udpipheader;
  struct ether_arp nh_arpheader;
#define nh_ipovlyheader nh_udpipheader.ui_i
#define nh_udpheader    nh_udpipheader.ui_u
} netheader;

struct  ether_header eheader;

struct packet {
  struct	ether_header	ts_eheader;
  struct ether_arp arp_header;
};

struct  ether_header ts_eheader;

#define Ntcp (sizeof(tcp)/sizeof(struct Stats))
#define Nudp (sizeof(udp)/sizeof(struct Stats))
#define BUFSPACE        4*8192
#define CHUNKSIZE       2048
#define MINPACKETLEN 60
#define IP              ((struct ip *)&netheader.nh_ipovlyheader)
#define ARP             (&netheader.nh_arpheader)
#define TYPE            (ntohs(eheader.ether_type))

/* GLOBALS */
char            etarget[6];
char            buf[BUFSPACE];
char            *edst, *esrc;
char	        *device;
int             if_fd, delay;
int             AllPkts, Pkts, arps, notip, ipmcasts;
int             wirelen, num_services;
extern int      errno;
static int	chunksize = CHUNKSIZE;
double          KBs;
struct stats    *info;
struct stat_info *currinfo;
